from django.db import models


# Create your models here.
# 类 - 表
# 属性 - 字段
# 类的实例对象 - 表里一行数据
class BookInfo(models.Model):
    # name, pub_date, readcount, commentcount, is_delete
    name = models.CharField(max_length=20, null=False, verbose_name='书名')
    pub_date = models.DateField(null=True, verbose_name='发布日期')
    readcount = models.IntegerField(default=0, verbose_name='阅读量')
    commentcount = models.IntegerField(default=0, verbose_name='评论量')
    is_delete = models.BooleanField(default=False, verbose_name='逻辑删除')

    def __str__(self):
        return self.name

    class Meta:
        db_table = 'bookinfo'


class PeopleInfo(models.Model):
    # name, gender, book_id, description, is_delete
    GENDER_CHOICES = (
        (0, 'male'),
        (1, 'female')
    )
    name = models.CharField(max_length=20, null=False, verbose_name='人名')
    gender = models.SmallIntegerField(choices=GENDER_CHOICES, default=0, verbose_name='性别')
    description = models.CharField(max_length=1000, verbose_name='人物描述')
    book = models.ForeignKey(BookInfo, on_delete=models.CASCADE, verbose_name='书籍')
    is_delete = models.BooleanField(default=False, verbose_name='逻辑删除')

    def __str__(self):
        return self.name

    class Meta:
        db_table = 'peopleinfo'
