from django.core.paginator import Paginator
from django.db.models import F, Q, Sum, Count
from django.http import HttpRequest, HttpResponse
from django.shortcuts import render


# Create your views here.
def book_list(request: HttpRequest):
    return HttpResponse('booklist')


# 插入数据
# 1.save
from book.models import BookInfo
# BookInfo(name='Python入门', pub_date='2010-01-01').save()
# 2.create
from book.models import PeopleInfo

# PeopleInfo.objects.create(name='woniuxuey', book=BookInfo(id=6))

# 修改数据
# 1.save
# p = PeopleInfo.objects.get(name='woniuxuey')
# p.name = "蜗牛学院"
# p.save()
# 2.update
# filter 查询返回的数据类型是 QuerySet
# PeopleInfo.objects.filter(name='蜗牛学院').update(name='woniuxy')

# 删除数据
# 1.delete
# PeopleInfo.objects.get(name='woniuxy').delete()
# 2.QuerySet().delete()
# BookInfo.objects.filter(name='Python入门').delete()

# 查询
# get 查询单一结果，模型类实例，如果不存在会抛出模型类 DoesNotExist 异常
# filter 过滤出多个结果，返回 QuerySet 类型对象
# exclude 排除掉符合条件剩下的结果，返回 QuerySet 类型对象
# all 查询多个结果，返回 QuerySet 类型对象
# count 查询结果数量
# BookInfo.objects.get(id=1)
# BookInfo.objects.exclude(id=1)
# BookInfo.objects.filter(id=1)
# BookInfo.objects.all()
# BookInfo.objects.count()

# 查询条件
# 查询编号为2的图书
# BookInfo.objects.filter(id__exact=2)
# BookInfo.objects.filter(id=2)
# # 查询书名包含'湖'的图书
# BookInfo.objects.filter(name__contains='湖')
# # 查询书名以'部'结尾的图书
# BookInfo.objects.filter(name__='部')
# # 查询书名为空的图书
# BookInfo.objects.filter(name__isnull=True)
# # 查询编号为2或3或5的图书
# BookInfo.objects.filter(id__in=[2, 3, 5])
# # 查询编号大于3的图书
# BookInfo.objects.filter(id__gt=3)
# # 查询1980年发表的图书
# BookInfo.objects.filter(pub_date__year__gt=1980)
# # 查询1990年1月1日后发表的图书
# BookInfo.objects.filter(pub_date__gt='1990-01-01')

# F对象
# # 查询阅读量大于等于评论量的图书。
# BookInfo.objects.filter(readcount__gt=F('commentcount'))
# # 查询阅读量大于2倍评论量的图书。
# BookInfo.objects.filter(readcount__gt=F("commentcount")*2)
# # 查询阅读量大于20，并且编号小于3的图书。
# BookInfo.objects.filter(readcount__gt=20, id__lt=3)
# BookInfo.objects.filter(readcount__gt=20).filter(id__lt=3)
# # 查询阅读量大于20的图书。
# BookInfo.objects.filter(Q(readcount__gt=20))
# # 查询阅读量大于20，或编号小于3的图书。
# BookInfo.objects.filter(Q(readcount__gt=20) | Q(id__lt=3))
# # 查询编号不等于3的图书
# BookInfo.objects.filter(~Q(id=3))


# 聚合函数
# # 查询id大于2的图书的总量和总阅读量
# BookInfo.objects.filter(id__gt=2).aggregate(Count('id'), Sum('readcount'))
# # 查询阅读总数大于10的图书总数。
# BookInfo.objects.filter(readcount__gt=10).count()
# 排序函数
# BookInfo.objects.all().order_by('readcount')

# 关联查询
# # 查询书籍id为1的所有人物信息
# BookInfo.objects.get(id=1).peopleinfo_set.all()
# # 查询人物id为1的书籍信息
# PeopleInfo.objects.get(id=1).book
# # 查询人物id为1的数据的id
# # 查询图书，要求图书人物为"郭靖"
# BookInfo.objects.filter(peopleinfo__name='郭靖')
# # 查询图书，要求图书中人物的描述包含"八"
# BookInfo.objects.filter(peopleinfo__description__contains="八")
# # 查询书名为“天龙八部”的所有人物
# PeopleInfo.objects.filter(book__name='天龙八部')
# BookInfo.objects.get(name='天龙八部').peopleinfo_set.all()
# # 查询图书阅读量大于30的所有人物
# PeopleInfo.objects.filter(book__readcount__gt=30)

BookInfo.objects.filter(readcount__gt=30).order_by('pub_date')

books = BookInfo.objects.all()
