"""bookmanager URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/1.11/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  url(r'^$', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  url(r'^$', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.conf.urls import url, include
    2. Add a URL to urlpatterns:  url(r'^blog/', include('blog.urls'))
"""
from django.conf.urls import url, include
from django.contrib import admin

from book.views import index

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    # url 函数的第一个参数正则表达式
    # url 函数的第二个参数是一个视图函数，或者是一个列表/元组
    # http://127.0.0.1:8000/index/index/ 把端口后面的 url 路径提出出来和正则表达式匹配
    # index/index/
    url(r'^', include('book.urls'))
]
